import java.net.*;

public class UAC implements Runnable {
	private Thread thread = null;
	private DatagramSocket socket = null;
	private DatagramPacket packet = null;
	private InetAddress local = null;

	public UAC(){
		try{
			local = InetAddress.getLocalHost();
		}catch(Exception e){e.printStackTrace();}
	}
	
	private String createRequest(){
		StringBuilder buf = new StringBuilder(256);
		buf.append("REGISTER sip:aaaaa@bbbbb.com");
		buf.append("\r\n");
		return buf.toString();
	}
     
     public void run(){
    	 try{
    		 socket = new DatagramSocket(Constant.uacPort);
    		 packet = new DatagramPacket(new byte[512], 512);
    	 }catch(Exception e){
    		 e.printStackTrace();
    		 return;
    	 }

    	 try{
    		 System.out.println("Wait for 5 seconds....");
    		 Thread.sleep(5 * 1000);
    		 
    		 while(true){
    			 String request = createRequest();
    			 packet.setData(request.getBytes());
    			 packet.setAddress(local);
    			 packet.setPort(Constant.serverPort);
    			 socket.send(packet);
    			 System.out.println("UAC sent a request");
    			 
    			 socket.receive(packet);
    		 }
    	 }catch(Exception e){e.printStackTrace();}
     }

     public synchronized void start() {
    	 this.thread = new Thread(this);
    	 thread.setDaemon(true);
    	 thread.setName("UAS");
    	 thread.start();
     }

}
